<template>
  <div>
    <!-- 島名 -->
    <div class="headline">{{ name }}</div>
    <!-- 最新カブ価 -->
    <v-container class="pa-0 mb-2">
      <v-row no-gutters>
        <!-- 最新カブ価 -->
        <v-col cols="6">
          <div class="display-4 pr-4 text-right">
            <strong>{{ latestPrice }}</strong>
          </div>
        </v-col>
        <!-- 最新カブ価変動割合 -->
        <v-col cols="6" class="pt-4">
          <div :class="latestPriceColor">
            <div class="headline">
                <strong>{{ latestPriceDifference }}</strong>
              </div>
            <div class="body-1">
              <strong>({{ latestPricePercentage }})</strong>
            </div>
          </div>
        </v-col>
      </v-row>
    </v-container>
    <!-- OHLC (始, 高, 安, 終) -->
    <v-container class="pa-0">
      <v-row no-gutters>
        <v-col cols="3">
          <div class="d-flex">
            <div class="grey darken-2 price-mark">始</div>
            <div class="price-body"><strong>{{ openHighLowClose.open }}</strong></div>
          </div>
        </v-col>
        <v-col cols="3">
          <div class="d-flex">
            <div class="grey darken-2 price-mark">高</div>
            <div class="price-body"><strong>{{ openHighLowClose.high }}</strong></div>
          </div>
        </v-col>
        <v-col cols="3">
          <div class="d-flex">
            <div class="grey darken-2 price-mark">安</div>
            <div class="price-body"><strong>{{ openHighLowClose.low }}</strong></div>
          </div>
        </v-col>
        <v-col cols="3">
          <div class="d-flex">
            <div class="grey darken-2 price-mark">終</div>
            <div class="price-body"><strong>{{ openHighLowClose.close }}</strong></div>
          </div>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
export default {
  computed: {
    // 島名
    name () {
      const name = this.$store.getters['stock/name']
      return name == null ? '島名未設定' : name + '島'
    },
    // 最新カブ価
    latestPrice () {
      const latestPrice = this.$store.getters['stock/latestPrices'].first
      return latestPrice == null ? '-' : latestPrice
    },
    // 最新カブ価変動値
    latestPriceDifference () {
      const difference = this.$store.getters['stock/latestPriceDifference']
      if (difference == null) {
        // nullの場合
        return 'N/A'
      } else if (difference > 0) {
        // 0より大きい場合
        return '+' + difference.toFixed()
      } else {
        // 0以下の場合
        return difference.toFixed()
      }
    },
    // 最新カブ価変動割合
    latestPricePercentage () {
      const percentage = this.$store.getters['stock/latestPricePercentage']
      if (percentage == null) {
        // nullの場合
        return 'N/A'
      } else if (percentage > 0) {
        // 0より大きい場合
        return '+' + percentage.toFixed(1) + '%'
      } else {
        // 0以下の場合
        return percentage.toFixed(1) + '%'
      }
    },
    // 最新カブ価変動の背景色クラス
    latestPriceColor () {
      const difference = this.$store.getters['stock/latestPriceDifference']
      if (difference == null || difference == 0) {
        // nullもしくは0の場合: 白
        return {
          'price-per': true,
          'grey': true,
          'darken-2': true,
        }
      } else {
        // nullもしくは0でない場合: 緑か赤
        return {
          'price-per': true,
          'green': difference > 0,
          'red': difference < 0
        }
      }
    },
    // OHLC
    openHighLowClose () {
      const ohlc = this.$store.getters['stock/openHighLowClose']
      const week = this.$store.getters['stock/latestPriceWeek']

      if (ohlc[week] == undefined) {
        // TODO: なぜか undefined になる
        return {
          open: '-',
          high: '-',
          low: '-',
          close: '-'
        }
      } else {
        return {
          open: ohlc[week].open || '-',
          high: ohlc[week].high || '-',
          low: ohlc[week].low || '-',
          close: ohlc[week].close || '-'
        }
      }
    }
  }
}
</script>

<style scoped>
.text-right {
  text-align: right;
}
.price-now {
  padding: 2px 0;
  margin-right: 16px;
}
.price-per {
  padding: 2px 16px;
  border-radius: 2px;
}
.price-mark {
  width: 50%;
  padding: 2px 0;
  border-radius: 2px;
  text-align: center;
}
.price-body {
  width: 50%;
  padding: 2px 0;
  text-align: center;
}
</style>
